program Speicheroszi_SOUNDBLASTER;
{Oszilloskop mit Soundblaster}
uses Crt,Graph,Dos;
       type   tmess             = array [1..31000] of Byte;
       var   mess                : tmess;
       var lpos,graphdriver,GraphError,graphmode,x,y,pos,xanf,portwert,wsw  : Integer;
           BA, zeit, unzeit                                                 : Word;
           ch, chw                                                          : char;
           auswert,zeitwert,wswert                                          : string;
           wert,tabr                                                        : Byte;
       label         wmenue;

  procedure Stdinitgraph;
  var grapherror, graphdriver, Graphmode                      : integer;
    begin
       graphdriver := detect;
       Initgraph(graphdriver,graphmode,'');
       Grapherror := IOResult;
         if grapherror <> GrOK
            then begin
               Closegraph;
               Writeln (' Fehler in den Graphiktreiberroutinen ');
               Writeln;
               Writeln (grapherrorMsg(grapherror) );
               Writeln;
               Writeln (' Programm wurde abgebrochen ! ');
               Halt
             end
   end;

  procedure loeschen;
    label    loe;
    begin
      asm
       push es
       mov ax,0a000H
       mov es,ax
       mov di,9600H
 @loe: mov byte ptr ES:[DI],00
       dec di
       jnz @loe
       pop es
      end;
    end;

       procedure anfang;
   begin
       port[96] := 243;
       Delay(100);
       port[96] := 0;
       loeschen;
       MoveTo(5,120);
       setColor(cyan);
       OutText('P R O G R A M M   O s z i l l o s k o p   m i t   S o u n d b l a s t e r  ') ;
       MoveTo(10,200);
       OutText('        erstellt von Dipl.- Ing.  Andreas Koehler  Dessau ');
       MoveTo(25,300);
       OutText('        weiter mit der Taste  ENTER  ');
       readln;
    end;

       procedure schnitt;
 label    m1, m2, m3;
    begin
       BA := 512;  {200 hex}
       asm
       mov bx,0008H   {8 Adressbereiche von 200H kontrollieren}
       mov dx,[BA]    {Grundadresse}
 @m2:  add dx,0006H    {Initport}
       mov cx,1000H
       mov al,01H
       out dx,al       {Ruecksetzen ausgeben}
       mov dx, [BA]
       add dx,000EH      {Statusport}
 @m1:  in al,dx          {lesen}
       and al,080H       {nur Bitwertigkeit 128}
       cmp al,080H       {gesetzt ?}
       jnz @m3             {gefunden}
       dec cx             {Anzahl Versuche verringern }
       jnz @m1            {ein wenig Zeit lassen}
       mov DX,[BA]
       add dx,0020H       {naechste Adresse}
       mov [BA],DX
       dec bx
       jnz @m2
       mov dx,0000DH      {wenn nicht gefunden ausrechnen von FFFF vorbereiten}
 @m3:  sub DX,0000EH      {Adresskorrektur}
       mov [BA],DX        {Adresse ablegen}
       end;
       if BA = 65536 then
           begin;
            Closegraph;
            Clrscr;
            writeln;
            writeln;
            writeln;
            writeln ('       P r o g r a m m    n i c h t    a u s f  h r b a r ');
            writeln;
            writeln;
            writeln ('       d a   k e i n e    S O U N D B L A S T E R   K a r t e  ');
            writeln;
            writeln;
            writeln ('                      w e i t e r   m i t    T a s t e ');
            readln;
            end;
            str(BA,auswert);
            MoveTo(120,20);
            OutText('Soundblaster gefunden auf Adresse  ');
            Outtext(auswert);
            readln;
     end;


  procedure messende;
    begin
     clearDevice;
     setcolor(green);
     MoveTo(40,300);
     OutText(' Eine Messung wurde gestartet und luft zur Zeit');
    end;

      procedure messen;
      label stat ;
      var   Status,verz                  :byte;
    begin
     messende;
         pos := 0;
        repeat
             Port [BA+12] := 32;
             for verz := 0 to 20 do   {sonst ist das Programm zu}
                begin                  {schnell fr den Soundblaster}
                end;
     stat :  status := (Port [BA+14] and 128);
             if (status <> 128 ) then goto stat;
             wert := port [BA+10];     {Adresse Datenport}
            mess[pos] := wert;
            pos := pos + 1;
        until (pos > 30000);
    end;


 procedure diskfehler;
 begin
   Setcolor(red);
   MoveTo(40,230);
   OutText(' F E H L E R   b e i   D I S K O P E R A T I O N ');
   Sound(1000);
   delay(2500);
   nosound;
   delay(3000);
 end;

 procedure speichern;
    var    name                    : string;
           Datei                   : file of Tmess;
    begin
        loeschen;
        MoveTo(40,80);
        OutText(' A b s p e i c h e r n   e i n e r   M e s s u n g ');
        MoveTo(40,195);
        OutText('Geben Sie den Dateinamen an : ');
        GotoXY(37,13);
        readln(name);
        assign(Datei,name);
        {$I-} rewrite(Datei); {$I+}
           if IOResult <> 0 then begin
               diskfehler;
               EXIT;
               end;
           write(Datei,tmess(mess));
        close(Datei);
    end;

 procedure laden;
    var      name                 : string;
             fileinfo             : Searchrec;
             Datei                : File of Tmess;
    begin
        loeschen;
        Setcolor(green);
        MoveTo(80,80);
        OutText('L a d e n   e i n e r   M e s s u n g ');
        MoveTo(40,195);
        OutText('Geben Sie den Dateinamen an : ');
        GotoXY(37,13);
        readln(name);
          Findfirst(name,anyfile,fileinfo);
            if Doserror <> 0  then begin
             diskfehler;
             exit;
             end;
        assign(Datei,name);
        Reset(Datei);
        read(Datei,Tmess(mess));
        Close(Datei);
    end;

 procedure anarahmen;
    begin
      SetColor(blue);
      rectangle(0,0,639,257);
      MoveTo(40,400);
      OutText('Abbruch der Analyse mit >ESC<');
      MoveTo(40,420);
      OutText('Bewegung des Cursors mit dem Ziffernblock');
    end;

 procedure zeichnen;
    begin
       x := 1;
       for pos := xanf to xanf + 638 do
           begin
            wert:= mess[pos];
            y := 256-wert;
            PutPixel(x,y,cyan);
            x:= x + 1;
           end;
    end;
 
 procedure linksrand;
    begin
       lpos :=1;
        loeschen;
        anarahmen;
        zeichnen;
        if xanf > 658 then
        begin
          xanf := xanf - 20;
          loeschen;
          anarahmen;
          zeichnen;
        end;
    end;

 procedure gracure;
    begin
      Setcolor(Black);
      Line(lpos,1,lpos,256);
      wert := mess[lpos+xanf-1];
      y:= 256-wert;
      PutPixel(lpos,y,cyan);
      lpos := lpos - wsw;
      pos:= pos - wsw;
      if lpos < 1 then linksrand;
      Setcolor(magenta);
      line (lpos,1,lpos,256);
      SetColor(black);
      MoveTo(200,360);
      outtext('');
     end;

 procedure rechtsrand;
    begin
      lpos := 638;
      loeschen;
      anarahmen;
      zeichnen;
      if xanf < 29352 then
       begin
          xanf := xanf + 20;
          loeschen;
          anarahmen;
          zeichnen;
       end;
     end;

 procedure graculi;
   begin
     Setcolor(Black);
     Line(lpos,1,lpos,256);
     wert := mess[xanf+lpos-1];
     y:= 256 - wert;
     PutPixel(lpos,y,cyan);
     lpos := lpos + wsw;
     pos:= pos + wsw;
     if lpos > 638 then
      begin
        rechtsrand;
      end;
        Setcolor(magenta);
        line (lpos,1,lpos,256);
        Setcolor(black);
        MoveTo(200,360);
        OutText('');
     end;

 procedure uwert;
   begin
   MoveTo(40,360);
   Setcolor(red);
   Outtext('Digitalwert  :');
   wert:= mess[xanf+lpos-1];
   portwert := wert;
   STR(portwert,auswert);
   MoveTo(200,360);
   Setcolor(red);
   outText(auswert);
   MoveTo(320,360);
   OutText('digit');
   end;

 procedure analyse;
    begin
        lpos:= 1;  {Cursorposition im Bild 1 ... 638)
        xanf := 1; {Dateiposition }
        loeschen;
        anarahmen;
        zeichnen;
        repeat;
            ch:= readkey;
              if ch = #27 then EXIT;
              if ch = #55 then Begin
                               wsw:=1;
                               gracure;
                               end;
              if ch = #57 then Begin
                               wsw:=1;
                               graculi;
                               end;
              if ch = #52 then Begin
                               wsw:=5;
                               gracure;
                               end;
              if ch = #54 then Begin
                               wsw:=5;
                               graculi;
                               end;
              if ch = #49 then Begin
                               wsw:=10;
                               gracure;
                               end;
              if ch = #51 then Begin
                               wsw:=10;
                               graculi;
                               end;
              uwert;
        until false;
         end;

 procedure ende;
     begin
      Closegraph;
      clrscr;
      GotoXY(5,10);
      Writeln('  E n d e   d e s   O s z i l l o s k o p p r o g r a m m s ');
      writeln;
      Writeln('        (c)  Dipl.- Ing. Andreas Koehler    ');
      writeln;
      writeln;
      writeln;
      writeln('     Dessau                              1997  ');
      writeln;
      writeln('           Weiter mit der  > ENTER < Taste ');
      readln
     end;


 procedure Menue;
  begin
      repeat
      ClearDevice;
      Setcolor(yellow);
      MoveTo(5,160);
      OutText('Messen ..........................................................  1');
      MoveTo(5,200);
      OutText('Abspeichern einer Messung auf Datentrger .......................  2');
      MoveTo(5,240);
      OutText('Laden einer Messung von Datentrger .............................  3');
      MoveTo(5,280);
      OutText('Analyse einer Messung ...........................................  4');
      MoveTo(5,320);
      outText('Ende ............................................................  5');
      MoveTo(5,360);
      OutText('Ihre Wahl bitte :');
      chw := readkey;
      if chw = '1' then messen;
      if chw = '2' then speichern ;
      if chw = '3' then laden ;
      if chw = '4' then analyse ;
      if chw = '5' then ende;
      until false;
  end;

begin
          Stdinitgraph;
          anfang;
          schnitt;
          pos:= 1;
wmenue:   menue;
          if chw <> '5' then goto wmenue;
          ende;

end.

